{ Written by David Billsbrough  }
{            Atlantic Beach, FL }
{            (904) 249-6982     }
{ Created: 12 March 1989 }
{ Version 01.00          }
{ Turbo Pascal v5.0      }

program GasGaugeDemo;
uses Crt;

var
  ch      : char;
  n       : byte;
  Gas     : real;
  Done,
  FuncKey : boolean;

procedure DrawGauge;
begin
  ClrScr;
  Gotoxy(5,5); Write('Ŀ');
  Gotoxy(5,6); Write('  E  1/8 1/4 3/8 1/2 5/8 3/4 7/8  F  ');
  Gotoxy(5,7); Write('                                     ');
  Gotoxy(5,8); Write('');
end;

procedure DrawNeedle;
begin
  Gotoxy(n, 7);
  Write(#127);
end;

procedure MoveNeedle;
begin
  if FuncKey then
    case ch of
      'K' : begin           {left arrow key}
              n := n - 4;
              if n < 8 then n := 8;
            end;
      'M' : begin           {right arrow key}
              n := n + 4;
              if n > 40 then n := 40;
            end;
    end
  else
    case ch of
      'E' : n := 8;    {empty tank}
      'H' : n := 24;   {tank is half-full}
      'F' : n := 40;   {full tank}
      #13 : Done := True;
    end;
end;

begin
  n := 24;
  Done := FALSE;

  DrawGauge;
  DrawNeedle;
  repeat
    ch := ReadKey;
    ch := UpCase(ch);
    if ch <> #0 then
      FuncKey := FALSE
    else begin
      FuncKey := TRUE;
      ch := ReadKey;
    end;
    Gotoxy(n, 7);
    Write(' ');
    MoveNeedle;
    DrawNeedle;
  until Done;
  Gas := ((n div 4) - 2) / 8;
  Gotoxy(1,12);
  WriteLn('Tank = ', Gas:5:3);
end.
