program covertidsbbbs;
{ converts ids.bbs file from version 2.1 to 3.0 }
type
  str2      = string[2];
  name      = string[14];
  longname  = string[25];
  person    = string[27];
  str10     = string[10];
  long      = string[150];
  newsysid  = record  {what the new record looks like}
                user: person;                   { handle }
                user2:longname;                 {real name}
                addr :longname;                 {street address}
                city :longname;                 {city}
                szip :longname;                 {state & zip }
                phnn :name;                     {phone number}
                exfl: byte;                     {EXPERT USER}
                lsto: name;                     {LAST TIME ON}
               intlg: name;                     {date first logged on}
                dld : integer;                  { # of downloads }
                uld : integer;                  { # of uploads }
                mptd: integer;                  { # of messages posted }
                lgdn: integer;                  { # of logons }
                lstm: array[1..20] of integer;  {LAST MESSAGE READ}
                pass: name;                     {PASSWORD}
                 acc: byte;                     {ACCESS LEVEL}
               speca: byte;                     {special access}
                clr:  name;                     {CLEAR SCREEN CHARATERS}
                bsp:  char;                     {BACKSPACE CHAR}
                lnf:  char;                     {LINEFEED CHAR}
                upc:  boolean;                  {UPPER CASE ONLY}
                wid:  byte;                     {SCREEN WIDTH}
                tdt:  byte;                     {today's date}
                tmo:  byte;                     {last month on}
                tyr:  byte;                     {last year on}
                tto:  byte;                     {min on today}
              end;
  oldsysid = record {what the old sysid looks like}
                user: person;                   { handle }
                user2:longname;                 {real name}
                addr :longname;                 {street address}
                city :longname;                 {city}
                szip :longname;                 {state & zip }
                phnn :name;                     {phone number}
                exfl: byte;                     {EXPERT USER}
                lsto: name;                     {LAST TIME ON}
               intlg: name;                     {date first logged on}
                dld : byte;                     { # of downloads }
                uld : byte;                     { # of uploads }
                mptd: byte;                     { # of messages posted }
                lgdn: byte;                     { # of logons }
                lstm: array[1..20] of integer;  {LAST MESSAGE READ}
                pass: name;                     {PASSWORD}
                 acc: byte;                     {ACCESS LEVEL}
               speca: byte;                     {special access}
                clr:  name;                     {CLEAR SCREEN CHARATERS}
                bsp:  char;                     {BACKSPACE CHAR}
                lnf:  char;                     {LINEFEED CHAR}
                upc:  boolean;                  {UPPER CASE ONLY}
                wid:  byte;                     {SCREEN WIDTH}
                tdt:  byte;                     {today's date}
                tto:  byte;                     {min on today}
              end;

var
  od : oldsysid;
  nd : newsysid;
  infile : file of oldsysid;
  outfile: file of newsysid;
  x,y,z : integer;
begin
  assign(infile,'IDS.BBS');
  reset(infile);
  x := filesize(infile);
  assign(outfile,'NEWIDS.BBS');
  rewrite(outfile);
  for y := 0 to x-1 do
    begin
      seek(infile,y);
      read(infile,od);
      nd.user    :=  od.user;
      nd.user2   :=  od.user2;
      nd.addr    :=  od.addr;
      nd.city    :=  od.city;
      nd.szip    :=  od.szip;
      nd.phnn    :=  od.phnn;
      nd.exfl    :=  od.exfl;
      nd.lsto    :=  od.lsto;
      nd.intlg   :=  od.intlg;
      nd.dld     :=  od.dld;
      nd.uld     :=  od.uld;
      nd.mptd    :=  od.mptd;
      nd.lgdn    :=  od.lgdn;
      for z := 1 to 20 do
        nd.lstm[z]    :=  od.lstm[z];
      nd.pass    :=  od.pass;
      nd.acc     :=  od.acc;
      nd.speca   :=  od.speca;
      nd.clr     :=  od.clr;
      nd.bsp     :=  od.bsp;
      nd.lnf     :=  od.lnf;
      nd.upc     :=  od.upc;
      nd.wid     :=  od.wid;
      nd.tdt     :=  od.tdt;
      nd.tto     :=  od.tto;
      nd.tyr     :=  80;
      nd.tmo     :=  1;

      seek(outfile,y);
      write(outfile,nd);
    end;
    close(infile);
    close(outfile);
end.



 
 

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
