PROGRAM CrossHair_Test;
{
 demos the HiGraf crosshair routines
}
{ comment out the following line if you do not wish to use the units from
  the Turbo Professional package from TurboPower Software }
{$DEFINE UseTurboProfessional}

{$IFDEF UseTurboProfessional}
USES TPCrt,Graph,Higraf;
{$ELSE}
USES Crt,Graph,Higraf;
{$ENDIF}
TYPE
  FLOAT = EXTENDED;
VAR
  x,y :FLOAT;
  xscreen,yscreen :INTEGER;
  key :CHAR;
BEGIN
  Initialize_Graph;
  SetClipOff;
  { print out some instructions and demo the crosshairs }
  OutTextXY(1,1,' Use "Arrow Keys" to move cursor around; "Home/End/PgUp/PgDn" keys');
  OutTextXY(1,15,' move cursor diagonally. <Ctrl>+ any of these keys is 10x faster.');
  OutTextXY(1,45,' Use "q", "Q", or <ESC> to quit.');
  SetClipOn;

  Initialize_CrossHairs;
  { for cross hairs to work, you need to do a Setup_Graph first }
  Setup_Graph(0.0,1.0,0.0,1.0,10,85,30,90,lin,lin);
  Frame(0.1,0.1,2,2,FALSE);

  { Move the cursor around }
  x := 0.5;
  y := 0.5;
  World_to_Window(x,y,xscreen,yscreen); { convert to window coords }
  REPEAT
    Update_CrossHairs(xscreen,yscreen,key);
  UNTIL ((key IN [#27,'q','Q']));

  CloseGraph;
END.