PROGRAM Cursor_Test;
{
 demos the HiGraf cursor routines
}
{ comment out the following line if you do not wish to use the units from
  the Turbo Professional package from TurboPower Software }
{$DEFINE UseTurboProfessional}

{$IFDEF UseTurboProfessional}
USES TPCrt,Graph,Higraf;
{$ELSE}
USES Crt,Graph,Higraf;
{$ENDIF}
TYPE
  FLOAT = EXTENDED;
VAR
  x,y :INTEGER;
  key :CHAR;
BEGIN
  DirectVideo := FALSE; { use BIOS for screen i/o for this demo; not
                          necessary generally }

  Initialize_Graph;
  Initialize_Cursor;

  { print out some instructions and demo the cursor }
  WRITELN(' Use "Arrow Keys" to move cursor around; "Home/End/PgUp/PgDn" keys');
  WRITELN(' move cursor diagonally. <Ctrl>+ any of these keys is 10x faster.');
  WRITELN(' (except <Ctrl> PgUp/PgDn does not work because of PC limitations)');
  WRITELN(' Use "q", "Q", or <ESC> to quit.');

  { Move the cursor around }
  x:=200;y:=200;
  REPEAT
    Update_Cursor(x,y,key);
  UNTIL ((key IN [#27,'q','Q']));

  CloseGraph;
END.