{ TPBoard 4.2 Copyright (c) 1987,88 by Jon Schneider & Rick Petersen  
  Portions Copyright (c) 1986,87 by Steve Fox and Les Archambault  
  
  Last modified  ::  9-11-88 5:47 pm 
}

{$R-}                             {Range checking off}
{$B-}                             {Boolean complete evaluation off}
{$S-}                             {Stack checking off}
{$I+}                             {I/O checking on}
{$N-}                             {No numeric coprocessor}

Unit MsgBuild;

Interface

Uses
  TPCrt, Dos, Globals, TAccess, Core1, Misc,
  Core2, TPSTRING, Dirs, MsgMove;
  
  
procedure make_message(dest_area       : Str13;
                       to_fn           : firstname;
                       to_ln           : lastname;
                       subj            : subject);
                       
                       
  {==========================================================================}
  
  
Implementation


  procedure make_message(dest_area       : Str13;
                         to_fn           : firstname;
                         to_ln           : lastname;
                         subj            : subject);
                         
    {makes a message entry from a disk file}
    
  var
    msg_status      : record_status;
    abort,
    created,
    NotSaved        : Boolean;
    Start           : LongInt;
    last_line,
    to_area         : Integer;
    from_loc,
    to_loc          : LongInt;
    from_fn         : FirstName;
    from_ln         : LastName;
    key             : StrName;
    msg_line        : message;
    temp_line       : string;
    mfile           : Text;
    mname           : Str13;
    temp_name       : DosFileName;
    t               : tad_array;
    This            : AreaPtr;
    Area            : Str10;
    
  begin
    created := False;
    if dest_area = '' then
      begin
        WriteLn(Com);
        OK := True;
        SetSect(HomName);
        repeat
          This := AreaBase;
          Area := prompt('Destination Message Area', 12, 'ES?M');
          if (Area = ' ') or (Area = '?') then
            begin
              WriteLn(Com);
              WriteLn(Com, 'Available message Areas:');
              WriteLn(Com);
              while This <> nil do
                begin
                  if This^.AreaName[1] <> '-' then
                    WriteLn(Com, This^.AreaName)
                  else
                    begin
                      temp_name := This^.AreaName;
                      Delete(temp_name, 1, 1);
                      WriteLn(Com, temp_name)
                    end;
                  This := This^.next;
                end;
              WriteLn(Com);
            end
          else
            begin
              This := AreaBase;
              while (This <> nil) and (Area <> Copy(This^.AreaName, 1, 8)) and
              (Pos(Area, This^.AreaName) <> 2) do
                This := This^.next;
            end;
        until (Area = This^.AreaName) or (Pos(Area, This^.AreaName) = 2) or (not Online);
        to_area := This^.Area;
        Area := This^.AreaName;
      end
    else
      begin
        This := AreaBase;
        while (This <> nil) and (dest_area <> This^.AreaName) and
        (Pos(dest_area, This^.AreaName) <> 2) do
          This := This^.next;
        to_area := This^.area;
        Area := This^.AreaName;
      end;
      
    if (Area <> 'NETMAIL') and (Area[1] <> '-') then
      begin
        if dest_area = '' then
          begin
            if (local_online and ask('Use editor to create the file', 'Y')) then
              begin
                mname := prompt('Name of file to create', 12, 'ES');
                DispName := mname;
                WriteLn(Com);
                full_screen_edit(mname, 'W', NotSaved);
              end
            else
              mname := prompt('Name of file in SYSTEM area to put into message'
                , 12, 'ES');
          end
        else
          begin
            created := True;
            mname := Copy(Area, 1, 8);
            mname := mname+'.MSG';
            WriteLn(Com);
          end;
          
        if mname <> ' ' then
          begin
            abort := False;
            Assign(mfile, mname);
            {$I-}
            Reset(mfile); {$I+}
            if (IoResult <> 0) then
              begin
                if (not created) then
                  begin
                    WriteLn(Com);
                    WriteLn(Com, 'Can Not find file ', mname);
                    WriteLn(Com);
                  end;
                OK := False;
              end;
            if OK then
              begin
                WriteLn(Com);
                if dest_area = '' then
                  begin
                    Write(Com, 'From: ', user_rec.fn, ' ', user_rec.ln);
                    if (not ask(' OK', 'Y')) then
                      begin
                        repeat
                          from_fn := prompt('From FIRST Name ', len_fn, 'ESN');
                          if from_fn = 'QUIT' then
                            abort := True
                          else
                            from_ln := prompt('From LAST Name  ', len_ln, 'ESN');
                          if from_ln = 'QUIT' then
                            abort := True;
                          if (not abort) then
                            begin
                              key := pad(from_ln, len_ln)+pad(from_fn, len_fn);
                              FindKey(IdxF, from_loc, key);
                              if not OK then
                                begin
                                  WriteLn(Com, from_fn, ' ', from_ln, ' not known on system.');
                                  WriteLn(Com, 'type QUIT to exit .');
                                end;
                            end;
                        until OK or abort or (not Online);
                      end         {get new FROM name}
                    else
                      from_loc := user_loc;
                  end
                else
                  from_loc := user_loc;
                OK := False;
                if (not abort) then
                  begin
                    repeat
                      if dest_area = '' then
                        to_fn := prompt('To FIRST name [CR for ALL]', len_fn, 'ESN')
                      else if to_fn = '' then
                        to_fn := ' ';
                      if to_fn = 'QUIT' then
                        abort := True
                      else if to_fn = ' ' then
                        begin
                          to_loc := 0;
                          msg_status := public;
                          OK := True;
                        end
                      else if to_fn = 'SYSOP' then
                        to_ln := ''
                      else if dest_area = '' then
                        to_ln := prompt('LAST name', len_ln, 'ESN');
                      if to_ln = 'QUIT' then
                        abort := True;
                      if (not OK) and (not abort) then
                        begin
                          key := pad(to_ln, len_ln)+pad(to_fn, len_fn);
                          FindKey(IdxF, to_loc, key);
                          if not OK then
                            begin
                              WriteLn(Com, to_fn, ' ', to_ln, ' not known on system.');
                              WriteLn(Com, 'type QUIT to exit .');
                            end;
                        end;
                    until (not Online) or OK or abort;
                    if abort or (not Online) then
                      OK := False;
                    if OK then
                      begin
                        if dest_area = '' then
                          subj := prompt('Subject', len_subj, 'EL');
                        if subj = '' then
                          subj := 'NONE';
                        if to_fn <> ' ' then
                          begin
                            if ask('Make Message PUBLIC', 'N') then
                              msg_status := public
                            else
                              msg_status := private;
                          end;
                          
                        Start := FileSize(mesg_file); {record msg lines}
                        Seek(mesg_file, Start);
                        last_line := 0; {$I+}
                        while (not EoF(mfile)) do
                          begin
                            ReadLn(mfile, msg_line);
                            temp_line := msg_line;
                            msg_line := Detab(temp_line, 8);
                            Write(mesg_file, msg_line);
                            Inc(last_line);
                          end;
                        Close(mfile);
                        if created then
                          Erase(mfile);
                          
                        GetTAD(t); {make summary file record}
                        Seek(summ_file, 0);
                        Read(summ_file, summ_rec);
                        with summ_rec do
                          begin
                            date := t;
                            status := msg_status;
                            Area := to_area;
                            Inc(num);
                            num_prev := 0;
                            num_next := 255;
                            user_from := from_loc;
                            user_to := to_loc;
                            subject := subj;
                            st_rec := Start;
                            size := last_line;
                          end;
                          
                        Seek(summ_file, 0);
                        Write(summ_file, summ_rec);
                        Seek(summ_file, FileSize(summ_file)); {add new record to end}
                        Write(summ_file, summ_rec);
                        mesg_insert(0);
                        WriteLn(Com);
                        Write(Com, 'Message ');
                        if dest_area = '' then
                          WriteLn(Com, 'built.')
                        else
                          WriteLn(Com, 'saved.');
                      end;        {OK second time}
                  end;            {not abort}
              end;                {OK}
          end;                    {Name<>' '}
      end
    else
      make_fido_message(Area, '', 0, 0, '', False, '', 0, 0, False);
  end;                            {make message}
  
  
end.                              { of MSGBUILD.PAS}

